/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the ComChannelPermission type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ComChannelPermission{}

// ComChannelPermission struct for ComChannelPermission
type ComChannelPermission struct {
	Status *string `json:"status,omitempty"`
	Timestamp *time.Time `json:"timestamp,omitempty"`
}

// NewComChannelPermission instantiates a new ComChannelPermission object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewComChannelPermission() *ComChannelPermission {
	this := ComChannelPermission{}
	return &this
}

// NewComChannelPermissionWithDefaults instantiates a new ComChannelPermission object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewComChannelPermissionWithDefaults() *ComChannelPermission {
	this := ComChannelPermission{}
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ComChannelPermission) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ComChannelPermission) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ComChannelPermission) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *ComChannelPermission) SetStatus(v string) {
	o.Status = &v
}

// GetTimestamp returns the Timestamp field value if set, zero value otherwise.
func (o *ComChannelPermission) GetTimestamp() time.Time {
	if o == nil || IsNil(o.Timestamp) {
		var ret time.Time
		return ret
	}
	return *o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ComChannelPermission) GetTimestampOk() (*time.Time, bool) {
	if o == nil || IsNil(o.Timestamp) {
		return nil, false
	}
	return o.Timestamp, true
}

// HasTimestamp returns a boolean if a field has been set.
func (o *ComChannelPermission) HasTimestamp() bool {
	if o != nil && !IsNil(o.Timestamp) {
		return true
	}

	return false
}

// SetTimestamp gets a reference to the given time.Time and assigns it to the Timestamp field.
func (o *ComChannelPermission) SetTimestamp(v time.Time) {
	o.Timestamp = &v
}

func (o ComChannelPermission) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ComChannelPermission) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.Timestamp) {
		toSerialize["timestamp"] = o.Timestamp
	}
	return toSerialize, nil
}

type NullableComChannelPermission struct {
	value *ComChannelPermission
	isSet bool
}

func (v NullableComChannelPermission) Get() *ComChannelPermission {
	return v.value
}

func (v *NullableComChannelPermission) Set(val *ComChannelPermission) {
	v.value = val
	v.isSet = true
}

func (v NullableComChannelPermission) IsSet() bool {
	return v.isSet
}

func (v *NullableComChannelPermission) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableComChannelPermission(val *ComChannelPermission) *NullableComChannelPermission {
	return &NullableComChannelPermission{value: val, isSet: true}
}

func (v NullableComChannelPermission) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableComChannelPermission) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


